type token =
  | EOF
  | VAR of (string)
  | TAG of (string)
  | STRING of (string)
  | LATEX of (string)
  | INCLUDE
  | LPAR
  | RPAR
  | BEGIN
  | END
  | LACC
  | RACC
  | LBRAC
  | RBRAC
  | EMPTY
  | UNDERSCORE
  | SUBSET
  | WITHCO
  | WITHOUTCO
  | WITHINIT
  | WITHOUTINIT
  | WITHSC
  | WITHOUTSC
  | ALT
  | SEMI
  | UNION
  | INTER
  | COMMA
  | DIFF
  | PLUSPLUS
  | STAR
  | PLUS
  | OPT
  | INV
  | COMP
  | HAT
  | LET
  | REC
  | AND
  | WHEN
  | ACYCLIC
  | IRREFLEXIVE
  | TESTEMPTY
  | EQUAL
  | SHOW
  | UNSHOW
  | AS
  | FUN
  | IN
  | PROCEDURE
  | CALL
  | FORALL
  | DO
  | FROM
  | TRY
  | INSTRUCTIONS
  | DEFAULT
  | IF
  | THEN
  | ELSE
  | YIELD
  | COMPAT
  | REQUIRES
  | FLAG
  | ARROW
  | ENUM
  | DEBUG
  | MATCH
  | WITH

open Parsing;;
let _ = parse_error;;
# 3 "lib/modelParser.mly"
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2013-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)


open AST

let mk_loc () =
  TxtLoc.make
    (Parsing.symbol_start_pos ())
    (Parsing.symbol_end_pos ())


let as_op op = function
  | Op (_,op0,es) when op0 = op -> es
  | e -> [e]

let do_op op e1 e2 =
  let es1 = as_op op e1
  and es2 = as_op op e2 in
  Op (mk_loc(),op,es1@es2)

let pp () =
  let open Lexing in
  let start = symbol_start_pos ()
  and fin = symbol_end () in
  let pos = start.pos_cnum in
  let len = fin - pos in
  Pos {pos;len}

# 118 "lib/modelParser.ml"
let yytransl_const = [|
    0 (* EOF *);
  261 (* INCLUDE *);
  262 (* LPAR *);
  263 (* RPAR *);
  264 (* BEGIN *);
  265 (* END *);
  266 (* LACC *);
  267 (* RACC *);
  268 (* LBRAC *);
  269 (* RBRAC *);
  270 (* EMPTY *);
  271 (* UNDERSCORE *);
  272 (* SUBSET *);
  273 (* WITHCO *);
  274 (* WITHOUTCO *);
  275 (* WITHINIT *);
  276 (* WITHOUTINIT *);
  277 (* WITHSC *);
  278 (* WITHOUTSC *);
  279 (* ALT *);
  280 (* SEMI *);
  281 (* UNION *);
  282 (* INTER *);
  283 (* COMMA *);
  284 (* DIFF *);
  285 (* PLUSPLUS *);
  286 (* STAR *);
  287 (* PLUS *);
  288 (* OPT *);
  289 (* INV *);
  290 (* COMP *);
  291 (* HAT *);
  292 (* LET *);
  293 (* REC *);
  294 (* AND *);
  295 (* WHEN *);
  296 (* ACYCLIC *);
  297 (* IRREFLEXIVE *);
  298 (* TESTEMPTY *);
  299 (* EQUAL *);
  300 (* SHOW *);
  301 (* UNSHOW *);
  302 (* AS *);
  303 (* FUN *);
  304 (* IN *);
  305 (* PROCEDURE *);
  306 (* CALL *);
  307 (* FORALL *);
  308 (* DO *);
  309 (* FROM *);
  310 (* TRY *);
  311 (* INSTRUCTIONS *);
  312 (* DEFAULT *);
  313 (* IF *);
  314 (* THEN *);
  315 (* ELSE *);
  316 (* YIELD *);
  317 (* COMPAT *);
  318 (* REQUIRES *);
  319 (* FLAG *);
  320 (* ARROW *);
  321 (* ENUM *);
  322 (* DEBUG *);
  323 (* MATCH *);
  324 (* WITH *);
    0|]

let yytransl_block = [|
  257 (* VAR *);
  258 (* TAG *);
  259 (* STRING *);
  260 (* LATEX *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\003\000\003\000\005\000\005\000\007\000\007\000\008\000\
\009\000\009\000\009\000\004\000\004\000\006\000\006\000\006\000\
\006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
\006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
\006\000\010\000\010\000\011\000\011\000\015\000\013\000\021\000\
\021\000\021\000\019\000\019\000\023\000\023\000\023\000\022\000\
\022\000\016\000\016\000\024\000\025\000\025\000\026\000\026\000\
\026\000\012\000\012\000\017\000\017\000\027\000\027\000\020\000\
\020\000\028\000\028\000\014\000\014\000\014\000\014\000\014\000\
\014\000\014\000\014\000\014\000\029\000\029\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\034\000\035\000\
\035\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\032\000\032\000\037\000\038\000\
\039\000\040\000\040\000\031\000\031\000\041\000\030\000\030\000\
\030\000\036\000\036\000\042\000\042\000\033\000\033\000\043\000\
\043\000\000\000"

let yylen = "\002\000\
\004\000\004\000\002\000\002\000\002\000\002\000\002\000\002\000\
\000\000\000\000\002\000\000\000\002\000\000\000\001\000\003\000\
\001\000\003\000\003\000\005\000\001\000\003\000\004\000\006\000\
\006\000\001\000\004\000\002\000\002\000\001\000\002\000\008\000\
\006\000\009\000\007\000\004\000\002\000\007\000\004\000\005\000\
\005\000\001\000\000\000\001\000\003\000\002\000\003\000\000\000\
\001\000\001\000\000\000\002\000\001\000\001\000\001\000\001\000\
\002\000\001\000\003\000\001\000\003\000\005\000\001\000\004\000\
\006\000\001\000\003\000\000\000\001\000\001\000\003\000\000\000\
\001\000\001\000\003\000\004\000\005\000\004\000\006\000\004\000\
\006\000\006\000\006\000\001\000\003\000\003\000\001\000\001\000\
\003\000\001\000\002\000\003\000\003\000\003\000\003\000\001\000\
\003\000\001\000\001\000\003\000\002\000\002\000\002\000\003\000\
\003\000\003\000\003\000\003\000\003\000\002\000\004\000\005\000\
\007\000\001\000\001\000\003\000\003\000\003\000\001\000\003\000\
\003\000\001\000\002\000\001\000\001\000\000\000\001\000\001\000\
\003\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\130\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\003\000\004\000\005\000\
\006\000\007\000\008\000\030\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\049\000\050\000\000\000\
\000\000\000\000\000\000\000\000\000\000\021\000\026\000\000\000\
\000\000\031\000\000\000\000\000\000\000\000\000\063\000\000\000\
\000\000\088\000\000\000\000\000\000\000\087\000\090\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\028\000\098\000\
\000\000\000\000\000\000\029\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\122\000\037\000\000\000\000\000\001\000\
\011\000\000\000\053\000\054\000\055\000\046\000\000\000\056\000\
\002\000\000\000\000\000\000\000\000\000\000\000\069\000\000\000\
\015\000\022\000\000\000\060\000\000\000\091\000\000\000\000\000\
\000\000\000\000\000\000\127\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\102\000\103\000\000\000\124\000\
\125\000\123\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\057\000\000\000\000\000\000\000\
\061\000\000\000\000\000\000\000\023\000\067\000\059\000\093\000\
\000\000\092\000\094\000\000\000\089\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\027\000\000\000\
\000\000\000\000\000\000\000\000\000\000\104\000\000\000\000\000\
\000\000\000\000\000\000\036\000\000\000\000\000\000\000\073\000\
\000\000\042\000\000\000\000\000\039\000\047\000\064\000\000\000\
\071\000\000\000\000\000\000\000\095\000\129\000\000\000\076\000\
\078\000\000\000\080\000\086\000\085\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\052\000\000\000\000\000\040\000\
\041\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\
\062\000\024\000\000\000\077\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\114\000\115\000\000\000\
\000\000\033\000\013\000\000\000\000\000\000\000\000\000\075\000\
\000\000\000\000\000\000\000\000\025\000\065\000\097\000\079\000\
\081\000\000\000\000\000\000\000\000\000\000\000\082\000\083\000\
\000\000\000\000\000\000\000\000\035\000\000\000\038\000\045\000\
\016\000\018\000\019\000\000\000\000\000\118\000\000\000\120\000\
\116\000\117\000\121\000\032\000\000\000\000\000\000\000\111\000\
\034\000\000\000\112\000\000\000\113\000"

let yydgoto = "\002\000\
\005\000\012\000\036\000\037\000\208\000\209\000\098\000\222\000\
\223\000\187\000\219\000\046\000\086\000\182\000\039\000\063\000\
\094\000\064\000\180\000\183\000\040\000\087\000\088\000\101\000\
\047\000\048\000\095\000\184\000\116\000\235\000\236\000\065\000\
\107\000\104\000\197\000\066\000\237\000\238\000\239\000\240\000\
\241\000\130\000\108\000"

let yysindex = "\029\000\
\152\255\000\000\202\255\202\255\000\000\202\255\202\255\202\255\
\202\255\202\255\202\255\181\255\181\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\034\255\005\255\146\255\045\255\
\026\255\063\255\067\255\083\255\087\255\000\000\000\000\099\255\
\161\255\161\255\106\255\108\000\181\255\000\000\000\000\124\255\
\110\000\000\000\016\255\127\255\017\255\086\255\000\000\112\255\
\114\255\000\000\047\255\161\255\161\255\000\000\000\000\124\003\
\014\255\020\255\161\255\161\255\161\255\113\255\000\000\000\000\
\001\003\111\255\114\255\000\000\123\255\148\255\135\000\109\255\
\156\255\158\255\129\255\000\000\000\000\105\255\128\255\000\000\
\000\000\193\255\000\000\000\000\000\000\000\000\161\255\000\000\
\000\000\134\255\127\255\161\255\151\255\177\255\000\000\236\254\
\000\000\000\000\017\255\000\000\045\255\000\000\002\255\183\255\
\182\255\171\255\188\255\000\000\159\255\017\255\153\255\138\255\
\127\255\137\255\247\254\154\255\143\255\205\255\124\003\124\003\
\124\003\124\003\124\003\220\001\000\000\000\000\194\255\000\000\
\000\000\000\000\173\255\127\255\126\255\168\255\161\255\161\255\
\161\255\206\255\206\255\161\255\000\000\168\255\161\255\231\255\
\000\000\127\255\196\255\124\255\000\000\000\000\000\000\000\000\
\161\255\000\000\000\000\161\255\000\000\197\255\161\255\161\255\
\234\255\161\255\161\255\161\255\161\255\206\255\000\000\014\002\
\001\003\157\255\157\255\051\003\159\255\000\000\175\002\244\255\
\217\255\127\255\006\000\000\000\219\255\242\255\245\255\000\000\
\005\000\000\000\017\000\023\255\000\000\000\000\000\000\233\255\
\000\000\161\255\086\255\250\255\000\000\000\000\161\255\000\000\
\000\000\214\255\000\000\000\000\000\000\220\255\101\255\025\000\
\175\002\251\255\175\002\041\000\000\000\175\002\161\255\000\000\
\000\000\031\000\000\000\247\255\253\255\035\000\053\000\161\255\
\000\000\000\000\161\255\000\000\161\255\161\255\027\255\008\000\
\054\000\012\000\071\000\072\000\060\000\000\000\000\000\065\000\
\076\000\000\000\000\000\175\002\078\000\057\000\094\000\000\000\
\017\000\175\002\175\002\023\255\000\000\000\000\000\000\000\000\
\000\000\112\000\118\000\161\255\056\000\161\255\000\000\000\000\
\122\000\116\000\103\255\121\000\000\000\175\002\000\000\000\000\
\000\000\000\000\000\000\098\000\082\000\000\000\161\255\000\000\
\000\000\000\000\000\000\000\000\139\000\150\000\161\255\000\000\
\000\000\088\000\000\000\161\255\000\000"

let yyrindex = "\000\000\
\000\000\000\000\208\003\208\003\000\000\208\003\208\003\208\003\
\208\003\208\003\208\003\044\000\044\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\044\000\000\000\000\000\000\000\
\000\000\000\000\000\000\146\000\000\000\053\003\000\000\212\002\
\009\001\000\000\000\000\000\000\151\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\082\002\001\000\101\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\146\000\000\000\154\000\000\000\000\000\053\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\152\000\000\000\000\000\131\000\000\000\000\000\000\000\
\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\066\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\146\000\000\000\166\003\000\000\153\000\
\153\000\162\000\107\255\000\000\000\000\005\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\136\255\000\000\204\001\
\147\002\074\001\139\001\016\002\196\000\000\000\051\255\000\000\
\000\000\146\000\000\000\000\000\000\000\155\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\053\003\171\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\056\255\000\000\051\255\000\000\000\000\051\255\000\000\000\000\
\000\000\250\003\000\000\000\000\000\000\175\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\176\000\000\000\000\000\051\255\000\000\000\000\000\000\000\000\
\000\000\056\255\051\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\051\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\246\000\255\255\000\000\092\255\058\000\160\255\000\000\
\192\000\125\255\198\000\215\255\044\001\236\255\000\000\237\255\
\167\255\064\000\053\001\065\001\000\000\000\000\124\001\000\000\
\000\000\000\000\062\001\251\000\000\000\200\000\000\000\210\255\
\000\000\000\000\242\000\000\000\204\000\000\000\000\000\206\000\
\000\000\000\000\060\001"

let yytablesize = 1342
let yytable = "\149\000\
\099\000\144\000\062\000\096\000\068\000\043\000\163\000\188\000\
\152\000\109\000\044\000\041\000\077\000\078\000\043\000\111\000\
\090\000\043\000\148\000\044\000\112\000\091\000\044\000\161\000\
\220\000\113\000\069\000\097\000\153\000\001\000\103\000\105\000\
\106\000\164\000\207\000\081\000\042\000\221\000\114\000\115\000\
\117\000\045\000\176\000\010\000\243\000\067\000\245\000\076\000\
\050\000\247\000\110\000\002\001\051\000\102\000\052\000\003\001\
\053\000\150\000\092\000\012\000\054\000\055\000\070\000\071\000\
\012\000\101\000\142\000\072\000\158\000\038\000\038\000\145\000\
\168\000\169\000\170\000\171\000\172\000\173\000\012\000\012\001\
\056\000\151\000\057\000\073\000\048\000\017\001\018\001\074\000\
\212\000\048\000\048\000\048\000\048\000\058\000\038\000\048\000\
\048\000\048\000\226\000\075\000\059\000\231\000\232\000\060\000\
\232\000\029\001\079\000\080\000\043\000\089\000\233\000\128\000\
\050\000\061\000\181\000\234\000\051\000\234\000\052\000\189\000\
\053\000\043\000\191\000\131\000\054\000\055\000\177\000\093\000\
\132\000\129\000\110\000\178\000\196\000\097\000\134\000\106\000\
\043\000\043\000\200\000\201\000\100\000\203\000\204\000\205\000\
\206\000\043\000\049\000\050\000\133\000\099\000\043\000\051\000\
\003\000\052\000\004\000\053\000\135\000\082\000\118\000\054\000\
\055\000\076\000\050\000\083\000\084\000\085\000\051\000\136\000\
\052\000\137\000\053\000\138\000\139\000\225\000\054\000\055\000\
\143\000\146\000\228\000\056\000\140\000\057\000\121\000\147\000\
\020\000\021\000\124\000\125\000\126\000\154\000\155\000\127\000\
\058\000\127\000\056\000\100\000\057\000\156\000\157\000\059\000\
\159\000\160\000\060\000\254\000\162\000\167\000\196\000\058\000\
\000\001\001\001\166\000\165\000\061\000\179\000\059\000\175\000\
\022\000\060\000\006\000\007\000\008\000\009\000\010\000\011\000\
\023\000\024\000\174\000\061\000\186\000\025\000\026\000\027\000\
\083\000\084\000\085\000\028\000\029\000\192\000\194\000\022\001\
\202\000\024\001\030\000\031\000\199\000\032\000\033\000\034\000\
\035\000\013\000\210\000\014\000\015\000\016\000\017\000\018\000\
\019\000\216\000\032\001\211\000\099\000\099\000\213\000\099\000\
\058\000\099\000\035\001\099\000\215\000\099\000\214\000\037\001\
\099\000\217\000\218\000\224\000\227\000\229\000\230\000\099\000\
\099\000\099\000\099\000\099\000\099\000\099\000\099\000\099\000\
\099\000\242\000\099\000\099\000\099\000\244\000\099\000\099\000\
\099\000\099\000\099\000\099\000\099\000\099\000\099\000\246\000\
\099\000\099\000\099\000\099\000\099\000\249\000\250\000\099\000\
\099\000\252\000\099\000\099\000\251\000\253\000\099\000\099\000\
\005\001\099\000\099\000\099\000\099\000\101\000\101\000\004\001\
\101\000\109\000\101\000\006\001\101\000\048\000\101\000\007\001\
\008\001\101\000\009\001\048\000\048\000\048\000\013\001\010\001\
\101\000\101\000\101\000\101\000\101\000\101\000\101\000\101\000\
\101\000\101\000\011\001\014\001\101\000\101\000\015\001\101\000\
\101\000\101\000\101\000\101\000\101\000\101\000\101\000\101\000\
\020\001\101\000\101\000\101\000\101\000\101\000\021\001\023\001\
\101\000\101\000\231\000\101\000\101\000\233\000\030\001\101\000\
\101\000\028\001\101\000\101\000\101\000\101\000\110\000\110\000\
\050\000\110\000\108\000\110\000\051\000\110\000\052\000\110\000\
\053\000\031\001\110\000\033\001\054\000\055\000\034\001\036\001\
\068\000\110\000\110\000\110\000\110\000\110\000\110\000\110\000\
\070\000\126\000\128\000\043\000\110\000\072\000\110\000\074\000\
\110\000\110\000\110\000\110\000\110\000\110\000\110\000\110\000\
\110\000\096\000\110\000\110\000\110\000\110\000\110\000\017\000\
\119\000\110\000\110\000\019\001\110\000\110\000\016\001\195\000\
\110\000\110\000\190\000\110\000\110\000\110\000\110\000\100\000\
\100\000\185\000\100\000\105\000\100\000\141\000\100\000\193\000\
\100\000\248\000\027\001\100\000\255\000\026\001\025\001\198\000\
\000\000\000\000\100\000\100\000\100\000\100\000\100\000\100\000\
\100\000\000\000\000\000\000\000\000\000\100\000\000\000\100\000\
\000\000\100\000\100\000\100\000\100\000\100\000\100\000\100\000\
\100\000\100\000\000\000\100\000\100\000\100\000\100\000\100\000\
\000\000\000\000\100\000\100\000\000\000\100\000\100\000\000\000\
\000\000\100\000\100\000\000\000\100\000\100\000\100\000\100\000\
\000\000\122\000\122\000\000\000\058\000\058\000\122\000\107\000\
\122\000\058\000\122\000\000\000\000\000\000\000\122\000\122\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\000\
\122\000\122\000\122\000\000\000\122\000\122\000\122\000\122\000\
\122\000\000\000\058\000\122\000\058\000\000\000\000\000\000\000\
\058\000\058\000\058\000\000\000\058\000\058\000\122\000\000\000\
\000\000\058\000\058\000\058\000\000\000\000\000\000\000\058\000\
\058\000\000\000\000\000\000\000\000\000\000\000\058\000\058\000\
\000\000\058\000\058\000\058\000\058\000\109\000\109\000\000\000\
\109\000\084\000\109\000\000\000\109\000\000\000\109\000\000\000\
\000\000\109\000\000\000\000\000\000\000\000\000\000\000\000\000\
\109\000\109\000\109\000\000\000\109\000\109\000\109\000\000\000\
\000\000\000\000\000\000\109\000\000\000\109\000\000\000\109\000\
\109\000\109\000\109\000\109\000\109\000\109\000\109\000\109\000\
\000\000\109\000\109\000\109\000\109\000\109\000\000\000\000\000\
\109\000\109\000\000\000\109\000\109\000\000\000\000\000\109\000\
\109\000\000\000\109\000\109\000\109\000\109\000\108\000\108\000\
\000\000\108\000\106\000\108\000\000\000\108\000\000\000\108\000\
\000\000\000\000\108\000\000\000\000\000\000\000\000\000\000\000\
\000\000\108\000\108\000\108\000\000\000\108\000\108\000\108\000\
\000\000\000\000\000\000\000\000\108\000\000\000\108\000\000\000\
\108\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\000\000\108\000\108\000\108\000\108\000\108\000\000\000\
\000\000\108\000\108\000\000\000\108\000\108\000\000\000\000\000\
\108\000\108\000\000\000\108\000\108\000\108\000\108\000\105\000\
\105\000\000\000\105\000\066\000\105\000\000\000\105\000\000\000\
\105\000\000\000\000\000\105\000\076\000\050\000\000\000\000\000\
\000\000\051\000\105\000\052\000\105\000\053\000\105\000\000\000\
\105\000\054\000\055\000\000\000\000\000\105\000\000\000\105\000\
\000\000\105\000\105\000\105\000\105\000\105\000\105\000\105\000\
\105\000\105\000\000\000\105\000\105\000\105\000\105\000\105\000\
\000\000\000\000\105\000\105\000\051\000\105\000\105\000\000\000\
\000\000\105\000\105\000\000\000\105\000\105\000\105\000\105\000\
\000\000\000\000\000\000\107\000\107\000\000\000\107\000\000\000\
\107\000\000\000\107\000\000\000\107\000\000\000\000\000\107\000\
\000\000\000\000\000\000\000\000\000\000\119\000\107\000\121\000\
\107\000\122\000\107\000\124\000\125\000\126\000\000\000\000\000\
\127\000\107\000\000\000\107\000\014\000\107\000\107\000\107\000\
\107\000\107\000\107\000\107\000\107\000\107\000\000\000\107\000\
\107\000\107\000\107\000\107\000\000\000\000\000\107\000\107\000\
\000\000\107\000\107\000\000\000\000\000\107\000\107\000\000\000\
\107\000\107\000\107\000\107\000\000\000\084\000\084\000\000\000\
\084\000\000\000\084\000\000\000\084\000\000\000\084\000\000\000\
\000\000\084\000\000\000\000\000\058\000\000\000\000\000\000\000\
\084\000\000\000\000\000\000\000\084\000\000\000\000\000\000\000\
\000\000\000\000\000\000\084\000\000\000\084\000\000\000\084\000\
\084\000\084\000\084\000\084\000\084\000\084\000\084\000\084\000\
\000\000\084\000\084\000\084\000\084\000\084\000\000\000\000\000\
\084\000\084\000\000\000\084\000\084\000\000\000\000\000\084\000\
\084\000\000\000\084\000\084\000\084\000\084\000\106\000\106\000\
\000\000\106\000\000\000\106\000\000\000\106\000\000\000\106\000\
\000\000\000\000\106\000\000\000\000\000\051\000\000\000\000\000\
\000\000\106\000\000\000\000\000\000\000\106\000\000\000\000\000\
\000\000\000\000\020\000\021\000\106\000\000\000\106\000\000\000\
\106\000\106\000\106\000\106\000\106\000\106\000\106\000\106\000\
\106\000\000\000\106\000\106\000\106\000\106\000\106\000\000\000\
\000\000\106\000\106\000\000\000\106\000\106\000\000\000\009\000\
\106\000\106\000\022\000\106\000\106\000\106\000\106\000\066\000\
\066\000\000\000\023\000\024\000\066\000\000\000\000\000\025\000\
\026\000\027\000\000\000\000\000\000\000\028\000\029\000\000\000\
\000\000\000\000\066\000\000\000\030\000\031\000\000\000\000\000\
\033\000\034\000\035\000\000\000\000\000\066\000\000\000\066\000\
\000\000\044\000\066\000\066\000\066\000\066\000\000\000\066\000\
\066\000\000\000\000\000\066\000\066\000\066\000\066\000\000\000\
\051\000\051\000\066\000\066\000\000\000\051\000\000\000\000\000\
\000\000\066\000\066\000\000\000\066\000\066\000\066\000\066\000\
\119\000\120\000\121\000\051\000\122\000\123\000\124\000\125\000\
\126\000\000\000\000\000\127\000\000\000\000\000\051\000\000\000\
\051\000\000\000\000\000\000\000\051\000\051\000\051\000\000\000\
\051\000\051\000\000\000\000\000\051\000\051\000\051\000\051\000\
\014\000\014\000\000\000\051\000\051\000\014\000\000\000\000\000\
\000\000\000\000\051\000\051\000\000\000\051\000\051\000\051\000\
\051\000\000\000\119\000\014\000\121\000\000\000\122\000\123\000\
\124\000\125\000\126\000\000\000\000\000\127\000\014\000\000\000\
\014\000\000\000\000\000\000\000\014\000\014\000\014\000\000\000\
\014\000\014\000\000\000\000\000\000\000\014\000\014\000\014\000\
\058\000\058\000\000\000\014\000\014\000\058\000\000\000\000\000\
\000\000\000\000\014\000\014\000\000\000\014\000\014\000\014\000\
\014\000\000\000\000\000\058\000\076\000\050\000\000\000\000\000\
\000\000\051\000\000\000\052\000\000\000\053\000\058\000\000\000\
\058\000\054\000\055\000\000\000\058\000\058\000\058\000\000\000\
\058\000\058\000\000\000\000\000\000\000\058\000\058\000\058\000\
\000\000\000\000\000\000\058\000\058\000\056\000\000\000\000\000\
\000\000\000\000\058\000\058\000\000\000\058\000\058\000\058\000\
\058\000\051\000\051\000\000\000\000\000\000\000\051\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\051\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\051\000\
\000\000\051\000\000\000\000\000\000\000\051\000\051\000\051\000\
\000\000\051\000\051\000\009\000\009\000\000\000\051\000\051\000\
\051\000\000\000\000\000\000\000\051\000\051\000\000\000\000\000\
\000\000\000\000\000\000\051\000\051\000\000\000\051\000\051\000\
\051\000\051\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\009\000\000\000\009\000\000\000\000\000\000\000\009\000\
\009\000\009\000\000\000\009\000\009\000\044\000\044\000\000\000\
\009\000\009\000\009\000\000\000\000\000\000\000\009\000\009\000\
\000\000\000\000\000\000\000\000\000\000\009\000\009\000\000\000\
\009\000\009\000\009\000\009\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\044\000\000\000\000\000\
\000\000\044\000\044\000\044\000\000\000\044\000\044\000\000\000\
\000\000\000\000\044\000\044\000\044\000\000\000\000\000\000\000\
\044\000\044\000\000\000\000\000\000\000\000\000\000\000\044\000\
\044\000\000\000\044\000\044\000\044\000\044\000"

let yycheck = "\096\000\
\000\000\091\000\023\000\045\000\024\000\001\001\016\001\139\000\
\007\001\056\000\006\001\013\000\033\000\034\000\001\001\057\000\
\001\001\001\001\039\001\006\001\001\001\006\001\006\001\113\000\
\002\001\006\001\001\001\048\001\027\001\001\000\051\000\052\000\
\053\000\043\001\166\000\037\000\003\001\015\001\059\000\060\000\
\061\000\037\001\132\000\000\000\209\000\001\001\211\000\001\001\
\002\001\214\000\037\001\025\001\006\001\007\001\008\001\029\001\
\010\001\099\000\043\001\009\001\014\001\015\001\037\001\001\001\
\009\001\000\000\087\000\001\001\110\000\012\000\013\000\092\000\
\119\000\120\000\121\000\122\000\123\000\124\000\023\001\244\000\
\034\001\101\000\036\001\001\001\034\001\250\000\251\000\001\001\
\178\000\034\001\040\001\041\001\042\001\047\001\037\000\040\001\
\041\001\042\001\195\000\001\001\054\001\001\001\002\001\057\001\
\002\001\014\001\001\001\000\000\002\001\000\000\010\001\001\001\
\002\001\067\001\135\000\015\001\006\001\015\001\008\001\140\000\
\010\001\015\001\143\000\001\001\014\001\015\001\001\001\001\001\
\006\001\066\000\000\000\006\001\153\000\048\001\071\000\156\000\
\001\001\002\001\159\000\160\000\027\001\162\000\163\000\164\000\
\165\000\010\001\001\001\002\001\001\001\038\001\015\001\006\001\
\001\001\008\001\003\001\010\001\048\001\034\001\046\001\014\001\
\015\001\001\001\002\001\040\001\041\001\042\001\006\001\012\001\
\008\001\012\001\010\001\043\001\068\001\194\000\014\001\015\001\
\043\001\027\001\199\000\034\001\053\001\036\001\026\001\007\001\
\004\001\005\001\030\001\031\001\032\001\007\001\009\001\035\001\
\047\001\035\001\034\001\000\000\036\001\027\001\011\001\054\001\
\048\001\064\001\057\001\224\000\068\001\001\001\227\000\047\001\
\229\000\230\000\068\001\058\001\067\001\046\001\054\001\043\001\
\036\001\057\001\017\001\018\001\019\001\020\001\021\001\022\001\
\044\001\045\001\033\001\067\001\023\001\049\001\050\001\051\001\
\040\001\041\001\042\001\055\001\056\001\007\001\043\001\004\001\
\007\001\006\001\062\001\063\001\048\001\065\001\066\001\067\001\
\068\001\004\000\007\001\006\000\007\000\008\000\009\000\010\000\
\011\000\013\001\023\001\043\001\004\001\005\001\001\001\007\001\
\000\000\009\001\031\001\011\001\027\001\013\001\052\001\036\001\
\016\001\013\001\002\001\043\001\027\001\064\001\059\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\009\001\034\001\035\001\036\001\043\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\007\001\
\048\001\049\001\050\001\051\001\052\001\023\001\064\001\055\001\
\056\001\023\001\058\001\059\001\064\001\009\001\062\001\063\001\
\011\001\065\001\066\001\067\001\068\001\004\001\005\001\064\001\
\007\001\000\000\009\001\064\001\011\001\034\001\013\001\009\001\
\009\001\016\001\023\001\040\001\041\001\042\001\009\001\023\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\023\001\043\001\035\001\036\001\009\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\001\001\048\001\049\001\050\001\051\001\052\001\001\001\064\001\
\055\001\056\001\001\001\058\001\059\001\010\001\029\001\062\001\
\063\001\009\001\065\001\066\001\067\001\068\001\004\001\005\001\
\002\001\007\001\000\000\009\001\006\001\011\001\008\001\013\001\
\010\001\064\001\016\001\009\001\014\001\015\001\001\001\064\001\
\007\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\007\001\011\001\011\001\002\001\034\001\013\001\036\001\013\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\007\001\048\001\049\001\050\001\051\001\052\001\009\001\
\009\001\055\001\056\001\252\000\058\001\059\001\249\000\148\000\
\062\001\063\001\142\000\065\001\066\001\067\001\068\001\004\001\
\005\001\137\000\007\001\000\000\009\001\082\000\011\001\146\000\
\013\001\215\000\011\001\016\001\227\000\010\001\009\001\156\000\
\255\255\255\255\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\255\255\255\255\255\255\255\255\034\001\255\255\036\001\
\255\255\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\255\255\048\001\049\001\050\001\051\001\052\001\
\255\255\255\255\055\001\056\001\255\255\058\001\059\001\255\255\
\255\255\062\001\063\001\255\255\065\001\066\001\067\001\068\001\
\255\255\001\001\002\001\255\255\004\001\005\001\006\001\000\000\
\008\001\009\001\010\001\255\255\255\255\255\255\014\001\015\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\023\001\
\024\001\025\001\026\001\255\255\028\001\029\001\030\001\031\001\
\032\001\255\255\034\001\035\001\036\001\255\255\255\255\255\255\
\040\001\041\001\042\001\255\255\044\001\045\001\046\001\255\255\
\255\255\049\001\050\001\051\001\255\255\255\255\255\255\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\062\001\063\001\
\255\255\065\001\066\001\067\001\068\001\004\001\005\001\255\255\
\007\001\000\000\009\001\255\255\011\001\255\255\013\001\255\255\
\255\255\016\001\255\255\255\255\255\255\255\255\255\255\255\255\
\023\001\024\001\025\001\255\255\027\001\028\001\029\001\255\255\
\255\255\255\255\255\255\034\001\255\255\036\001\255\255\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\255\255\048\001\049\001\050\001\051\001\052\001\255\255\255\255\
\055\001\056\001\255\255\058\001\059\001\255\255\255\255\062\001\
\063\001\255\255\065\001\066\001\067\001\068\001\004\001\005\001\
\255\255\007\001\000\000\009\001\255\255\011\001\255\255\013\001\
\255\255\255\255\016\001\255\255\255\255\255\255\255\255\255\255\
\255\255\023\001\024\001\025\001\255\255\027\001\028\001\029\001\
\255\255\255\255\255\255\255\255\034\001\255\255\036\001\255\255\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\255\255\048\001\049\001\050\001\051\001\052\001\255\255\
\255\255\055\001\056\001\255\255\058\001\059\001\255\255\255\255\
\062\001\063\001\255\255\065\001\066\001\067\001\068\001\004\001\
\005\001\255\255\007\001\000\000\009\001\255\255\011\001\255\255\
\013\001\255\255\255\255\016\001\001\001\002\001\255\255\255\255\
\255\255\006\001\023\001\008\001\025\001\010\001\027\001\255\255\
\029\001\014\001\015\001\255\255\255\255\034\001\255\255\036\001\
\255\255\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\255\255\048\001\049\001\050\001\051\001\052\001\
\255\255\255\255\055\001\056\001\000\000\058\001\059\001\255\255\
\255\255\062\001\063\001\255\255\065\001\066\001\067\001\068\001\
\255\255\255\255\255\255\004\001\005\001\255\255\007\001\255\255\
\009\001\255\255\011\001\255\255\013\001\255\255\255\255\016\001\
\255\255\255\255\255\255\255\255\255\255\024\001\023\001\026\001\
\025\001\028\001\027\001\030\001\031\001\032\001\255\255\255\255\
\035\001\034\001\255\255\036\001\000\000\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\255\255\048\001\
\049\001\050\001\051\001\052\001\255\255\255\255\055\001\056\001\
\255\255\058\001\059\001\255\255\255\255\062\001\063\001\255\255\
\065\001\066\001\067\001\068\001\255\255\004\001\005\001\255\255\
\007\001\255\255\009\001\255\255\011\001\255\255\013\001\255\255\
\255\255\016\001\255\255\255\255\000\000\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\255\255\255\255\255\255\
\255\255\255\255\255\255\034\001\255\255\036\001\255\255\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\255\255\048\001\049\001\050\001\051\001\052\001\255\255\255\255\
\055\001\056\001\255\255\058\001\059\001\255\255\255\255\062\001\
\063\001\255\255\065\001\066\001\067\001\068\001\004\001\005\001\
\255\255\007\001\255\255\009\001\255\255\011\001\255\255\013\001\
\255\255\255\255\016\001\255\255\255\255\000\000\255\255\255\255\
\255\255\023\001\255\255\255\255\255\255\027\001\255\255\255\255\
\255\255\255\255\004\001\005\001\034\001\255\255\036\001\255\255\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\255\255\048\001\049\001\050\001\051\001\052\001\255\255\
\255\255\055\001\056\001\255\255\058\001\059\001\255\255\000\000\
\062\001\063\001\036\001\065\001\066\001\067\001\068\001\004\001\
\005\001\255\255\044\001\045\001\009\001\255\255\255\255\049\001\
\050\001\051\001\255\255\255\255\255\255\055\001\056\001\255\255\
\255\255\255\255\023\001\255\255\062\001\063\001\255\255\255\255\
\066\001\067\001\068\001\255\255\255\255\034\001\255\255\036\001\
\255\255\000\000\039\001\040\001\041\001\042\001\255\255\044\001\
\045\001\255\255\255\255\048\001\049\001\050\001\051\001\255\255\
\004\001\005\001\055\001\056\001\255\255\009\001\255\255\255\255\
\255\255\062\001\063\001\255\255\065\001\066\001\067\001\068\001\
\024\001\025\001\026\001\023\001\028\001\029\001\030\001\031\001\
\032\001\255\255\255\255\035\001\255\255\255\255\034\001\255\255\
\036\001\255\255\255\255\255\255\040\001\041\001\042\001\255\255\
\044\001\045\001\255\255\255\255\048\001\049\001\050\001\051\001\
\004\001\005\001\255\255\055\001\056\001\009\001\255\255\255\255\
\255\255\255\255\062\001\063\001\255\255\065\001\066\001\067\001\
\068\001\255\255\024\001\023\001\026\001\255\255\028\001\029\001\
\030\001\031\001\032\001\255\255\255\255\035\001\034\001\255\255\
\036\001\255\255\255\255\255\255\040\001\041\001\042\001\255\255\
\044\001\045\001\255\255\255\255\255\255\049\001\050\001\051\001\
\004\001\005\001\255\255\055\001\056\001\009\001\255\255\255\255\
\255\255\255\255\062\001\063\001\255\255\065\001\066\001\067\001\
\068\001\255\255\255\255\023\001\001\001\002\001\255\255\255\255\
\255\255\006\001\255\255\008\001\255\255\010\001\034\001\255\255\
\036\001\014\001\015\001\255\255\040\001\041\001\042\001\255\255\
\044\001\045\001\255\255\255\255\255\255\049\001\050\001\051\001\
\255\255\255\255\255\255\055\001\056\001\034\001\255\255\255\255\
\255\255\255\255\062\001\063\001\255\255\065\001\066\001\067\001\
\068\001\004\001\005\001\255\255\255\255\255\255\009\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\023\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\034\001\
\255\255\036\001\255\255\255\255\255\255\040\001\041\001\042\001\
\255\255\044\001\045\001\004\001\005\001\255\255\049\001\050\001\
\051\001\255\255\255\255\255\255\055\001\056\001\255\255\255\255\
\255\255\255\255\255\255\062\001\063\001\255\255\065\001\066\001\
\067\001\068\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\034\001\255\255\036\001\255\255\255\255\255\255\040\001\
\041\001\042\001\255\255\044\001\045\001\004\001\005\001\255\255\
\049\001\050\001\051\001\255\255\255\255\255\255\055\001\056\001\
\255\255\255\255\255\255\255\255\255\255\062\001\063\001\255\255\
\065\001\066\001\067\001\068\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\034\001\255\255\036\001\255\255\255\255\
\255\255\040\001\041\001\042\001\255\255\044\001\045\001\255\255\
\255\255\255\255\049\001\050\001\051\001\255\255\255\255\255\255\
\055\001\056\001\255\255\255\255\255\255\255\255\255\255\062\001\
\063\001\255\255\065\001\066\001\067\001\068\001"

let yynames_const = "\
  EOF\000\
  INCLUDE\000\
  LPAR\000\
  RPAR\000\
  BEGIN\000\
  END\000\
  LACC\000\
  RACC\000\
  LBRAC\000\
  RBRAC\000\
  EMPTY\000\
  UNDERSCORE\000\
  SUBSET\000\
  WITHCO\000\
  WITHOUTCO\000\
  WITHINIT\000\
  WITHOUTINIT\000\
  WITHSC\000\
  WITHOUTSC\000\
  ALT\000\
  SEMI\000\
  UNION\000\
  INTER\000\
  COMMA\000\
  DIFF\000\
  PLUSPLUS\000\
  STAR\000\
  PLUS\000\
  OPT\000\
  INV\000\
  COMP\000\
  HAT\000\
  LET\000\
  REC\000\
  AND\000\
  WHEN\000\
  ACYCLIC\000\
  IRREFLEXIVE\000\
  TESTEMPTY\000\
  EQUAL\000\
  SHOW\000\
  UNSHOW\000\
  AS\000\
  FUN\000\
  IN\000\
  PROCEDURE\000\
  CALL\000\
  FORALL\000\
  DO\000\
  FROM\000\
  TRY\000\
  INSTRUCTIONS\000\
  DEFAULT\000\
  IF\000\
  THEN\000\
  ELSE\000\
  YIELD\000\
  COMPAT\000\
  REQUIRES\000\
  FLAG\000\
  ARROW\000\
  ENUM\000\
  DEBUG\000\
  MATCH\000\
  WITH\000\
  "

let yynames_block = "\
  VAR\000\
  TAG\000\
  STRING\000\
  LATEX\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'options) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'topins_list) in
    Obj.repr(
# 80 "lib/modelParser.mly"
                              ( _2, _1,_3 )
# 790 "lib/modelParser.ml"
               : AST.t))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'options) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'topins_list) in
    Obj.repr(
# 81 "lib/modelParser.mly"
                                 ( _2,_1,_3 )
# 799 "lib/modelParser.ml"
               : AST.t))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'options) in
    Obj.repr(
# 84 "lib/modelParser.mly"
                 ( ModelOption.set_enumco true _2 )
# 806 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'options) in
    Obj.repr(
# 85 "lib/modelParser.mly"
                    ( ModelOption.set_enumco false _2 )
# 813 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'options) in
    Obj.repr(
# 86 "lib/modelParser.mly"
                   ( ModelOption.set_init true _2 )
# 820 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'options) in
    Obj.repr(
# 87 "lib/modelParser.mly"
                      ( ModelOption.set_init false _2 )
# 827 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'options) in
    Obj.repr(
# 88 "lib/modelParser.mly"
                 ( ModelOption.set_enumsc true _2 )
# 834 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'options) in
    Obj.repr(
# 89 "lib/modelParser.mly"
                    ( ModelOption.set_enumsc false _2 )
# 841 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    Obj.repr(
# 90 "lib/modelParser.mly"
     ( ModelOption.default )
# 847 "lib/modelParser.ml"
               : 'options))
; (fun __caml_parser_env ->
    Obj.repr(
# 93 "lib/modelParser.mly"
  ( [] )
# 853 "lib/modelParser.ml"
               : 'topins_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'topins) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'topins_list) in
    Obj.repr(
# 94 "lib/modelParser.mly"
                     ( _1 :: _2 )
# 861 "lib/modelParser.ml"
               : 'topins_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 97 "lib/modelParser.mly"
  ( [] )
# 867 "lib/modelParser.ml"
               : 'ins_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ins) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ins_list) in
    Obj.repr(
# 98 "lib/modelParser.mly"
               ( _1 :: _2 )
# 875 "lib/modelParser.ml"
               : 'ins_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 101 "lib/modelParser.mly"
     ( () )
# 881 "lib/modelParser.ml"
               : 'in_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 102 "lib/modelParser.mly"
     ( () )
# 887 "lib/modelParser.ml"
               : 'in_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ins_list) in
    Obj.repr(
# 105 "lib/modelParser.mly"
                     ( _1,_3 )
# 895 "lib/modelParser.ml"
               : 'ins_clause))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ins_clause) in
    Obj.repr(
# 108 "lib/modelParser.mly"
             ( [_1],None )
# 902 "lib/modelParser.ml"
               : 'ins_clause_list))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ins_list) in
    Obj.repr(
# 109 "lib/modelParser.mly"
                            ( [],Some _3 )
# 909 "lib/modelParser.ml"
               : 'ins_clause_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ins_clause) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ins_clause_list) in
    Obj.repr(
# 111 "lib/modelParser.mly"
    (
     let cls,d = _3 in
     _1 :: cls, d
    )
# 920 "lib/modelParser.ml"
               : 'ins_clause_list))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'altopt) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'alttags) in
    Obj.repr(
# 118 "lib/modelParser.mly"
                                ( Enum (mk_loc (),_2,_5) )
# 929 "lib/modelParser.ml"
               : 'topins))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ins) in
    Obj.repr(
# 119 "lib/modelParser.mly"
      ( _1 )
# 936 "lib/modelParser.ml"
               : 'topins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'pat_bind_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'in_opt) in
    Obj.repr(
# 123 "lib/modelParser.mly"
                           ( Let (mk_loc (),_2) )
# 944 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pat_bind_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'in_opt) in
    Obj.repr(
# 124 "lib/modelParser.mly"
                                ( Rec (mk_loc (),_3,None) )
# 952 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'pat_bind_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'app_test) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'in_opt) in
    Obj.repr(
# 125 "lib/modelParser.mly"
                                             ( Rec (mk_loc (),_3,Some _5) )
# 961 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'exp) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'altopt) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'ins_clause_list) in
    Obj.repr(
# 127 "lib/modelParser.mly"
    (
     let cls,d = _5 in
     InsMatch (mk_loc(),_2,cls,d)
    )
# 973 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'deftest) in
    Obj.repr(
# 131 "lib/modelParser.mly"
          ( _1 )
# 980 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 132 "lib/modelParser.mly"
                  ( ShowAs (mk_loc(),_2, _4) )
# 988 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_list) in
    Obj.repr(
# 133 "lib/modelParser.mly"
                ( Show (mk_loc(),_2) )
# 995 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_list) in
    Obj.repr(
# 134 "lib/modelParser.mly"
                  ( UnShow (mk_loc(),_2) )
# 1002 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 135 "lib/modelParser.mly"
        ( Latex (mk_loc(),_1) )
# 1009 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 136 "lib/modelParser.mly"
                 ( Include (mk_loc(),_2) )
# 1016 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 6 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'formals) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'ins_list) in
    Obj.repr(
# 138 "lib/modelParser.mly"
   ( Procedure (mk_loc (),_2,Ptuple _4,_7,IsNotRec) )
# 1025 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'ins_list) in
    Obj.repr(
# 140 "lib/modelParser.mly"
   ( Procedure (mk_loc (),_2,Pvar _3,_5,IsNotRec) )
# 1034 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 6 : string) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : 'formals) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : 'ins_list) in
    Obj.repr(
# 143 "lib/modelParser.mly"
   ( Procedure (mk_loc (),_3,Ptuple _5,_8,IsRec) )
# 1043 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'ins_list) in
    Obj.repr(
# 145 "lib/modelParser.mly"
   ( Procedure (mk_loc (),_3,Pvar _4,_6,IsRec) )
# 1052 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'simple) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'optional_name) in
    Obj.repr(
# 147 "lib/modelParser.mly"
                                ( Call (mk_loc (),_2,_3,_4) )
# 1061 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 148 "lib/modelParser.mly"
            ( Debug (mk_loc (),_2) )
# 1068 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'exp) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'ins_list) in
    Obj.repr(
# 150 "lib/modelParser.mly"
    ( Forall (mk_loc (),_2,_4,_6) )
# 1077 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 152 "lib/modelParser.mly"
    ( WithFrom (mk_loc (),_2,_4) )
# 1085 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'exp_list) in
    Obj.repr(
# 156 "lib/modelParser.mly"
                                         (Events(mk_loc(),_2,_4,false))
# 1093 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'exp_list) in
    Obj.repr(
# 157 "lib/modelParser.mly"
                                    (Events(mk_loc(),_2,_4,true))
# 1101 "lib/modelParser.ml"
               : 'ins))
; (fun __caml_parser_env ->
    Obj.repr(
# 161 "lib/modelParser.mly"
       ( () )
# 1107 "lib/modelParser.ml"
               : 'altopt))
; (fun __caml_parser_env ->
    Obj.repr(
# 162 "lib/modelParser.mly"
       ( () )
# 1113 "lib/modelParser.ml"
               : 'altopt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 165 "lib/modelParser.mly"
      ( [_1] )
# 1120 "lib/modelParser.ml"
               : 'alttags))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'alttags) in
    Obj.repr(
# 166 "lib/modelParser.mly"
                  ( _1 :: _3 )
# 1128 "lib/modelParser.ml"
               : 'alttags))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'test_type) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'app_test) in
    Obj.repr(
# 169 "lib/modelParser.mly"
                     ( Test (_2,_1) )
# 1136 "lib/modelParser.ml"
               : 'deftest))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'test) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'optional_name) in
    Obj.repr(
# 173 "lib/modelParser.mly"
                         ( (mk_loc(),pp (),_1,_2,_3) )
# 1145 "lib/modelParser.ml"
               : 'app_test))
; (fun __caml_parser_env ->
    Obj.repr(
# 176 "lib/modelParser.mly"
           ( Check )
# 1151 "lib/modelParser.ml"
               : 'test_type))
; (fun __caml_parser_env ->
    Obj.repr(
# 177 "lib/modelParser.mly"
           ( UndefinedUnless )
# 1157 "lib/modelParser.ml"
               : 'test_type))
; (fun __caml_parser_env ->
    Obj.repr(
# 178 "lib/modelParser.mly"
           ( Flagged )
# 1163 "lib/modelParser.ml"
               : 'test_type))
; (fun __caml_parser_env ->
    Obj.repr(
# 181 "lib/modelParser.mly"
         ( None )
# 1169 "lib/modelParser.ml"
               : 'optional_name))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 182 "lib/modelParser.mly"
         ( Some _2 )
# 1176 "lib/modelParser.ml"
               : 'optional_name))
; (fun __caml_parser_env ->
    Obj.repr(
# 185 "lib/modelParser.mly"
          ( Acyclic )
# 1182 "lib/modelParser.ml"
               : 'do_test))
; (fun __caml_parser_env ->
    Obj.repr(
# 186 "lib/modelParser.mly"
              ( Irreflexive )
# 1188 "lib/modelParser.ml"
               : 'do_test))
; (fun __caml_parser_env ->
    Obj.repr(
# 187 "lib/modelParser.mly"
            ( TestEmpty )
# 1194 "lib/modelParser.ml"
               : 'do_test))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'do_test) in
    Obj.repr(
# 190 "lib/modelParser.mly"
          ( Yes _1 )
# 1201 "lib/modelParser.ml"
               : 'test))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'do_test) in
    Obj.repr(
# 191 "lib/modelParser.mly"
               ( No _2)
# 1208 "lib/modelParser.ml"
               : 'test))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 194 "lib/modelParser.mly"
      ( [_1] )
# 1215 "lib/modelParser.ml"
               : 'var_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'comma_opt) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'var_list) in
    Obj.repr(
# 195 "lib/modelParser.mly"
                         ( _1 :: _3 )
# 1224 "lib/modelParser.ml"
               : 'var_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 199 "lib/modelParser.mly"
        ( () )
# 1230 "lib/modelParser.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 202 "lib/modelParser.mly"
                ( (mk_loc (),Pvar _1,_3) )
# 1238 "lib/modelParser.ml"
               : 'bind))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'formals) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 203 "lib/modelParser.mly"
                              ( (mk_loc (),Ptuple _2,_5) )
# 1246 "lib/modelParser.ml"
               : 'bind))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'bind) in
    Obj.repr(
# 205 "lib/modelParser.mly"
       ( _1 )
# 1253 "lib/modelParser.ml"
               : 'pat_bind))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 207 "lib/modelParser.mly"
   ( (mk_loc (),Pvar _1,Fun (mk_loc(),Pvar _2,_4,_1,ASTUtils.free_body [_2] _4)) )
# 1262 "lib/modelParser.ml"
               : 'pat_bind))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'formals) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 209 "lib/modelParser.mly"
   ( (mk_loc(),Pvar _1,Fun (mk_loc(),Ptuple _3,_6,_1,ASTUtils.free_body _3 _6)) )
# 1271 "lib/modelParser.ml"
               : 'pat_bind))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pat_bind) in
    Obj.repr(
# 212 "lib/modelParser.mly"
           ( [_1] )
# 1278 "lib/modelParser.ml"
               : 'pat_bind_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'pat_bind) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pat_bind_list) in
    Obj.repr(
# 213 "lib/modelParser.mly"
                             ( _1 :: _3 )
# 1286 "lib/modelParser.ml"
               : 'pat_bind_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 217 "lib/modelParser.mly"
           ( [] )
# 1292 "lib/modelParser.ml"
               : 'formals))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'formalsN) in
    Obj.repr(
# 218 "lib/modelParser.mly"
           ( _1 )
# 1299 "lib/modelParser.ml"
               : 'formals))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 221 "lib/modelParser.mly"
                     ( [_1] )
# 1306 "lib/modelParser.ml"
               : 'formalsN))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'formalsN) in
    Obj.repr(
# 222 "lib/modelParser.mly"
                     ( _1 :: _3 )
# 1314 "lib/modelParser.ml"
               : 'formalsN))
; (fun __caml_parser_env ->
    Obj.repr(
# 225 "lib/modelParser.mly"
  ( [] )
# 1320 "lib/modelParser.ml"
               : 'exp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exp_listN) in
    Obj.repr(
# 226 "lib/modelParser.mly"
            ( _1 )
# 1327 "lib/modelParser.ml"
               : 'exp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 229 "lib/modelParser.mly"
      ([_1])
# 1334 "lib/modelParser.ml"
               : 'exp_listN))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exp_listN) in
    Obj.repr(
# 230 "lib/modelParser.mly"
                      ( _1 :: _3)
# 1342 "lib/modelParser.ml"
               : 'exp_listN))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'pat_bind_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 233 "lib/modelParser.mly"
                           ( Bind (mk_loc(),_2,_4) )
# 1350 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'pat_bind_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 234 "lib/modelParser.mly"
                               ( BindRec (mk_loc(),_3,_5) )
# 1358 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 236 "lib/modelParser.mly"
    ( Fun (mk_loc(),Pvar _2,_4,"*fun*",ASTUtils.free_body [_2] _4) )
# 1366 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'formals) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 238 "lib/modelParser.mly"
    ( Fun (mk_loc(),Ptuple _3,_6,"*fun*",ASTUtils.free_body _3 _6) )
# 1374 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 240 "lib/modelParser.mly"
    ( Try (mk_loc(),_2,_4) )
# 1382 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'cond) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 242 "lib/modelParser.mly"
    ( If (mk_loc(),_2,_4,_6) )
# 1391 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'exp) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'altopt) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'clause_list) in
    Obj.repr(
# 244 "lib/modelParser.mly"
    (
     let cls,d = _5 in
     Match (mk_loc(),_2,cls,d)
    )
# 1403 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'exp) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'altopt) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'set_clauses) in
    Obj.repr(
# 249 "lib/modelParser.mly"
    (
     let e,f = _5 in
     MatchSet (mk_loc (),_2,e,f)
   )
# 1415 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 253 "lib/modelParser.mly"
       ( _1 )
# 1422 "lib/modelParser.ml"
               : 'exp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 256 "lib/modelParser.mly"
                 ( Eq (_1,_3) )
# 1430 "lib/modelParser.ml"
               : 'cond))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 257 "lib/modelParser.mly"
                 ( Subset (_1,_3) )
# 1438 "lib/modelParser.ml"
               : 'cond))
; (fun __caml_parser_env ->
    Obj.repr(
# 260 "lib/modelParser.mly"
        ( Konst (mk_loc(),Empty RLN) )
# 1444 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 261 "lib/modelParser.mly"
       ( Tag (mk_loc (),_1) )
# 1451 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'args) in
    Obj.repr(
# 262 "lib/modelParser.mly"
                 ( ExplicitSet (mk_loc (),_2) )
# 1458 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    Obj.repr(
# 263 "lib/modelParser.mly"
              ( Konst (mk_loc(),Universe SET) )
# 1464 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    Obj.repr(
# 264 "lib/modelParser.mly"
            ( Op (mk_loc (),Tuple,[]) )
# 1470 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tupleargs) in
    Obj.repr(
# 265 "lib/modelParser.mly"
                      ( Op (mk_loc (),Tuple,_2) )
# 1477 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exp) in
    Obj.repr(
# 266 "lib/modelParser.mly"
                ( _2 )
# 1484 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exp) in
    Obj.repr(
# 267 "lib/modelParser.mly"
                ( _2 )
# 1491 "lib/modelParser.ml"
               : 'simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tupleend) in
    Obj.repr(
# 270 "lib/modelParser.mly"
                     ( _1 :: _3 )
# 1499 "lib/modelParser.ml"
               : 'tupleargs))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 273 "lib/modelParser.mly"
      ( [_1] )
# 1506 "lib/modelParser.ml"
               : 'tupleend))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tupleend) in
    Obj.repr(
# 274 "lib/modelParser.mly"
                     ( _1 :: _3 )
# 1514 "lib/modelParser.ml"
               : 'tupleend))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'simple) in
    Obj.repr(
# 277 "lib/modelParser.mly"
         ( _1 )
# 1521 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exp0) in
    Obj.repr(
# 278 "lib/modelParser.mly"
       ( _1 )
# 1528 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 279 "lib/modelParser.mly"
                 (Op (mk_loc(),Cartesian, [_1; _3]))
# 1536 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'base) in
    Obj.repr(
# 280 "lib/modelParser.mly"
            ( Op1(mk_loc(),Star,_1) )
# 1543 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'base) in
    Obj.repr(
# 281 "lib/modelParser.mly"
            ( Op1(mk_loc(),Plus,_1) )
# 1550 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'base) in
    Obj.repr(
# 282 "lib/modelParser.mly"
           ( Op1(mk_loc(),Opt,_1) )
# 1557 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    Obj.repr(
# 283 "lib/modelParser.mly"
               ( Op1(mk_loc(),Inv,_1) )
# 1564 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 284 "lib/modelParser.mly"
                 ( do_op Seq _1 _3 )
# 1572 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 285 "lib/modelParser.mly"
                  ( do_op Union _1 _3 )
# 1580 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 286 "lib/modelParser.mly"
                     ( Op (mk_loc (), Add, [_1; _3]) )
# 1588 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 287 "lib/modelParser.mly"
                 ( Op (mk_loc (),Diff, [_1; _3;]) )
# 1596 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'base) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 288 "lib/modelParser.mly"
                  (  Op (mk_loc (),Inter, [_1; _3;]) )
# 1604 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'base) in
    Obj.repr(
# 289 "lib/modelParser.mly"
            ( Op1 (mk_loc(),Comp, _2) )
# 1611 "lib/modelParser.ml"
               : 'base))
; (fun __caml_parser_env ->
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 292 "lib/modelParser.mly"
                      ( _4 )
# 1618 "lib/modelParser.ml"
               : 'empty_clause))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 295 "lib/modelParser.mly"
                             ( EltRem (_1, _3, _5) )
# 1627 "lib/modelParser.ml"
               : 'element_clause2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 298 "lib/modelParser.mly"
                                       ( PreEltPost (_1,_3,_5,_7) )
# 1637 "lib/modelParser.ml"
               : 'element_clause3))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'element_clause2) in
    Obj.repr(
# 301 "lib/modelParser.mly"
                  ( _1 )
# 1644 "lib/modelParser.ml"
               : 'element_clause))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'element_clause3) in
    Obj.repr(
# 302 "lib/modelParser.mly"
                  ( _1 )
# 1651 "lib/modelParser.ml"
               : 'element_clause))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'empty_clause) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'element_clause) in
    Obj.repr(
# 305 "lib/modelParser.mly"
                                  ( _1, _3 )
# 1659 "lib/modelParser.ml"
               : 'set_clauses))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'element_clause) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'empty_clause) in
    Obj.repr(
# 306 "lib/modelParser.mly"
                                  ( _3, _1 )
# 1667 "lib/modelParser.ml"
               : 'set_clauses))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 309 "lib/modelParser.mly"
                ( _1,_3 )
# 1675 "lib/modelParser.ml"
               : 'clause))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'clause) in
    Obj.repr(
# 312 "lib/modelParser.mly"
         ( [_1],None )
# 1682 "lib/modelParser.ml"
               : 'clause_list))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 313 "lib/modelParser.mly"
                       ( [],Some _3 )
# 1689 "lib/modelParser.ml"
               : 'clause_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'clause) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'clause_list) in
    Obj.repr(
# 315 "lib/modelParser.mly"
    (
     let cls,d = _3 in
     _1 :: cls, d
    )
# 1700 "lib/modelParser.ml"
               : 'clause_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 322 "lib/modelParser.mly"
                      ( Var (mk_loc (),_1) )
# 1707 "lib/modelParser.ml"
               : 'exp0))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'exp0) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'arg) in
    Obj.repr(
# 323 "lib/modelParser.mly"
                             ( App (mk_loc (),_1,_2) )
# 1715 "lib/modelParser.ml"
               : 'exp0))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 326 "lib/modelParser.mly"
      ( Var (mk_loc (),_1) )
# 1722 "lib/modelParser.ml"
               : 'arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'simple) in
    Obj.repr(
# 327 "lib/modelParser.mly"
         ( _1 )
# 1729 "lib/modelParser.ml"
               : 'arg))
; (fun __caml_parser_env ->
    Obj.repr(
# 331 "lib/modelParser.mly"
  ( [] )
# 1735 "lib/modelParser.ml"
               : 'args))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argsN) in
    Obj.repr(
# 332 "lib/modelParser.mly"
        ( _1 )
# 1742 "lib/modelParser.ml"
               : 'args))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exp) in
    Obj.repr(
# 335 "lib/modelParser.mly"
                 ( [ _1 ] )
# 1749 "lib/modelParser.ml"
               : 'argsN))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'exp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argsN) in
    Obj.repr(
# 336 "lib/modelParser.mly"
                  ( _1 :: _3 )
# 1757 "lib/modelParser.ml"
               : 'argsN))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : AST.t)
