type token =
  | EOF
  | PROC of (int)
  | SYMB_REG of (string)
  | NAME of (string)
  | DOLLARNAME of (string)
  | NUM of (int)
  | TRUE
  | FALSE
  | EQUAL
  | PLUS_DISJ
  | FINAL
  | FORALL
  | EXISTS
  | OBSERVED
  | TOKAND
  | NOT
  | AND
  | OR
  | IMPLIES
  | CASES
  | WITH
  | LOCATIONS
  | STAR
  | LBRK
  | RBRK
  | LPAR
  | RPAR
  | SEMI
  | COLON
  | AMPER
  | ATOMIC
  | PTX_REG_DEC
  | PTX_REG_TYPE of (string)

val init :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> MiscParser.state
val location :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> MiscParser.location
val constraints :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (MiscParser.location * MiscParser.run_type) list * MiscParser.constr * (string * MiscParser.quantifier) list
val constr :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> MiscParser.constr
val skip_loc_constr :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> MiscParser.constr
val loc_constr :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (MiscParser.location * MiscParser.run_type) list * MiscParser.constr
val locs :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> MiscParser.location list
